\environment entorn

\starttext

\startsubject[title={Equacions de primer grau amb parèntesis}]

\startsubsubject[title={Preguntes}]

<%

exercicis = Hash.new

%>

<%# Exercici 1 %>
<%
exercicis[1] = Array.new

  parametres = Hash.new
  parametres['a'] = rand(1..10)
  parametres['b'] = rand(1..10)
  parametres['c'] = rand(1..20)
  parametres['d'] = rand(1..20)
  
  # Evit el cas de divisió per 0 en tots els apartats. I en cas que algun denominador sigui zero, canvip a paràmetres que, amb un poc d'àlgebra, m'he assegurat que no tenen aquest problema
  if (parametres['a'] + parametres['c'] == 0) or (parametres['a']*parametres['b'] -1 == 0) or (parametres['a'] - parametres['b'] == 0) or (parametres['a'] - parametres['c'] == 1) or (parametres['a'] - parametres['c'] == 6) or (parametres['b'] - parametres['c'] == 0) or (-parametres['a'] + parametres['d'] == 2)
    parametres['b'] = parametres['a'] + 1
    parametres['c'] = parametres['a']
    parametres['d'] = parametres['a']
  end
  
  exercicis[1].push(parametres)
%>

\startexercici[reference=exercici-1] Resoleu les equacions:
\startitemize[a, columns]
<% exercicis[1].each do |par| %>
\item $<%=par['a']%>(x + <%=par['b']%>) = -<%=par['c']%>x + <%=par['d']%>$

\item $<%=par['a']%>(<%=par['b']%>x - <%=par['c']%>) = <%=par['d']%> + x$

\item $<%=par['a']%>x - (<%=par['b']%>x -<%=par['c']%>) = <%=par['d']%>$

\item $<%=par['a']%>x - (x-<%=par['b']%>) = <%=par['c']%>x + <%=par['d']%>$

\item $<%=par['a']%>(x + <%=par['b']%>) - (<%=par['c']%>x + <%=par['d']%>) =6x+18$

\item $5-(<%=par['a']%>- <%=par['b']%>x) = <%=par['c']%>(x + <%=par['d']%>)-3$

\item 2x - ($<%=par['a']%>x - <%=par['b']%>) = <%=par['c']%> - <%=par['d']%>x$

\item $-(<%=par['a']%> - <%=par['b']%>x) = <%=par['c']%>(x + <%=par['d']%>) + 2$
<% end %>
\stopitemize
\stopexercici


<%# Exercici 3 %>
<%
exercicis[3] = Array.new

  parametres = Hash.new
  
  parametres['a'] = rand(-10..10)  
  parametres['b'] = rand(1..10)
  parametres['c'] = rand(-20..20)  
  parametres['d'] = rand(1..20)
  parametres['e'] = rand(1..20)

  # Evit el 0x
  if parametres['a'] == 0
    parametres['a'] = 5
  end

  if parametres['c'] == 0
    parametres['c'] = 3
  end

  if parametres['e'] == 0
    parametres['e'] = 1
  end
  
  # Evit el conjunt de casos en què els denominadors són 0
  if (parametres['c'] == 1 + parametres['a'] - parametres['e']) or (parametres['b'] == -1 + parametres['a'] - parametres['e'])
    parametres['c'] = 1 + parametres['a']
    parametres['b'] = 2 + paramentres['a']
  end
  
  exercicis[3].push(parametres)
%>


\startexercici[reference=exercici-3] Resoleu les equacions següents:
\startitemize[a]
<% exercicis[3].each do |par| %>
\item $<%=par['a']%>(<%=par['b']%> - x) = x - (<%=par['c']%>x - <%=par['d']%>) - <%=par['e']%>(x-5)$
\item $<%=par['a']%>x - (<%=par['b']%>x + <%=par['c']%>) = x - (<%=par['d']%> - <%=par['e']%>x)$
<% end %>
\stopitemize
\stopexercici

\stopsubsubject

<%# ----------------------- Solucions ------------------------ %>
\page[yes]
\startsubsubject[title={Solucions}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
<% 
   solucio_1 = Rational(par['d']-par['a']*par['b'],par['a']+par['c'])
   solucio_2 = Rational(par['d']-par['a']*par['c'],par['a']*par['b']-1)
   solucio_3 = Rational(par['d']-par['c'],par['a']-par['b'])
   solucio_4 = Rational(par['d']-par['b'],par['a']-par['c']-1)
   solucio_5 = Rational(18-par['a']*par['b']+par['d'],par['a']-par['c']-6)
   solucio_6 = Rational(par['a']+par['c']*par['d']-8,par['b']-par['c'])
   solucio_7 = Rational(par['c']-par['b'],-par['a']+par['d']+2)
   solucio_8 = Rational(par['c']*par['d']+par['a']+2,par['b']-par['c'])
%>
\item $x = \frac{<%=solucio_1.numerator%>}{<%=solucio_1.denominator%>}$
\item $x = \frac{<%=solucio_2.numerator%>}{<%=solucio_2.denominator%>}$
\item $x = \frac{<%=solucio_3.numerator%>}{<%=solucio_3.denominator%>}$
\item $x = \frac{<%=solucio_4.numerator%>}{<%=solucio_4.denominator%>}$
\item $x = \frac{<%=solucio_5.numerator%>}{<%=solucio_5.denominator%>}$
\item $x = \frac{<%=solucio_6.numerator%>}{<%=solucio_6.denominator%>}$
\item $x = \frac{<%=solucio_7.numerator%>}{<%=solucio_7.denominator%>}$
\item $x = \frac{<%=solucio_8.numerator%>}{<%=solucio_8.denominator%>}$
<% end %>
\stopitemize

\sym{\in[exercici-3]}
\startitemize[a, text]
<% exercicis[3].each do |par| %>
<% 
   solucio_1 = Rational(5*par['e']+par['d']-par['a']*par['b'],-par['a']+par['c']+par['e']-1)
   solucio_2 = Rational(-par['d']+par['c'],par['a']-par['b']-1-par['e'])

%>
\item $x = \frac{<%=solucio_1.numerator%>}{<%=solucio_1.denominator%>}$
\item $x = \frac{<%=solucio_2.numerator%>}{<%=solucio_2.denominator%>}$
<% end %>
\stopitemize

\stopitemize

\vfill
Les solucions d'aquests exercicis s'han calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

<%# ----------------------- Resolució ------------------------ %>
\page[yes]
\startsubsubject[title={Resolució}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']

   solucio_1 = Rational(par['d']-par['a']*par['b'],par['a']+par['c'])
   solucio_2 = Rational(par['d']-par['a']*par['c'],par['a']*par['b']-1)
   solucio_3 = Rational(par['d']-par['c'],par['a']-par['b'])
   solucio_4 = Rational(par['d']-par['b'],par['a']-par['c']-1)
   solucio_5 = Rational(18-par['a']*par['b']+par['d'],par['a']-par['c']-6)
   solucio_6 = Rational(par['a']+par['c']*par['d']-8,par['b']-par['c'])
   solucio_7 = Rational(par['c']-par['b'],-par['a']+par['d']+2)
   solucio_8 = Rational(par['c']*par['d']+par['a']+2,par['b']-par['c'])

%>

\item $<%=a%>(x + <%=b%>) = -<%=c%>x + <%=d%>$ $\Rightarrow$ $<%=a%>x + <%=a * b%> = -<%=c%>x + <%=d%>$ $\Rightarrow$ $<%=a+c%>x = <%=d%> - <%=a*b%>$ $\Rightarrow$ $x = \frac{<%=solucio_1.numerator%>}{<%=solucio_1.denominator%>}$

\item $<%=par['a']%>(<%=par['b']%>x - <%=par['c']%>) = <%=par['d']%> + x$ $\Rightarrow$ $<%=a*b%>x - <%=a*c%> = <%=d%> + x$ $\Rightarrow$ $<%=a*b%>x - x = <%=d%> + <%= a*c%>$ $\Rightarrow$ $<%=a*b-1%>x = <%=d + a*c%>$ $\Rightarrow$ $x = \frac{<%=solucio_2.numerator%>}{<%=solucio_2.denominator%>}$

\item $<%=par['a']%>x - (<%=par['b']%>x -<%=par['c']%>) = <%=par['d']%>$ $\Rightarrow$ $<%=a%>x - <%=b%>x + <%=c%> = <%=d%>$ $\Rightarrow$ $<%=a-b%>x = <%=d-c%>$ $\Rightarrow$ $x = \frac{<%=solucio_3.numerator%>}{<%=solucio_3.denominator%>}$

\item $<%=par['a']%>x - (x-<%=par['b']%>) = <%=par['c']%>x + <%=par['d']%>$ $\Rightarrow$ $<%=a%>x - x + <%=b%> = <%=c%>x + <%=d%>$ $\Rightarrow$ $<%=a-c-1%>x = <%=d-b%>$ $\Rightarrow$ $x = \frac{<%=solucio_4.numerator%>}{<%=solucio_4.denominator%>}$

\item $<%=par['a']%>(x + <%=par['b']%>) - (<%=par['c']%>x + <%=par['d']%>) = 6x+18$ $\Rightarrow$ $<%=a%>x + <%=a*b%> -<%=c%>x - <%=d%> = 6x + 18$ $\Rightarrow$ $<%=a%>x - <%=c%>x -6x = 18 -<%=a*b%> + <%=d%>$ $\Rightarrow$ $<%=a-c-6%>x = <%=18-a*b+d%>$ $\Rightarrow$ $x = \frac{<%=solucio_5.numerator%>}{<%=solucio_5.denominator%>}$

\item $5-(<%=par['a']%>- <%=par['b']%>x) = <%=par['c']%>(x + <%=par['d']%>)-3$ $\Rightarrow$ $5-<%=a%> + <%=b%>x = <%=c%>x + <%=c*d%> -3$ $\Rightarrow$ $<%=b%>x - <%=c%>x = <%=c*d%> -3 -5 + <%=a%>$ $\Rightarrow$ $<%=b-c%>x = <%=a+c*d -8%>$ $\Rightarrow$ $x = \frac{<%=solucio_6.numerator%>}{<%=solucio_6.denominator%>}$

\item 2x - ($<%=par['a']%>x - <%=par['b']%>) = <%=par['c']%> - <%=par['d']%>x$ $\Rightarrow$ $2x - <%=a%>x + <%=b%> = <%=c%> - <%=d%>x$ $\Rightarrow$ $<%=2-a+d%>x = <%=c-b%>$ $\Rightarrow$ $x = \frac{<%=solucio_7.numerator%>}{<%=solucio_7.denominator%>}$

\item $-(<%=par['a']%> - <%=par['b']%>x) = <%=par['c']%>(x + <%=par['d']%>) + 2$ $\Rightarrow$ $-<%=a%> + <%=b%>x = <%=c%>x + <%=c*d%> + 2$ $\Rightarrow$ $<%=b%>x - <%=c%>x = <%=c*d%> + 2 + <%=a%>$ $\Rightarrow$ $<%=b-c%>x = <%=c*d+a+2%>$ $\Rightarrow$ $x = \frac{<%=solucio_8.numerator%>}{<%=solucio_8.denominator%>}$

<% end %>
\stopitemize


\sym{\in[exercici-3]}
\startitemize[a, text]
<% exercicis[3].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
   e = par['e']
   
   solucio_1 = Rational(5*par['e']+par['d']-par['a']*par['b'],-par['a']+par['c']+par['e']-1)
   solucio_2 = Rational(-par['d']+par['c'],par['a']-par['b']-1-par['e'])

%>
\item $<%=par['a']%>(<%=par['b']%> - x) = x - (<%=par['c']%>x - <%=par['d']%>) - <%=par['e']%>(x-5)$ $\Rightarrow$ $<%=a*b%> - <%=a%>x = x - <%=c%>x + <%=d%> -<%=e%>x + <%=5*e%>$ $\Rightarrow$ $<%=-a-1+c+e%>x = <%=5*e%> + <%=d%> - <%=a*b%>$ $\Rightarrow$ $x = \frac{<%=solucio_1.numerator%>}{<%=solucio_1.denominator%>}$

\item $<%=par['a']%>x - (<%=par['b']%>x + <%=par['c']%>) = x - (<%=par['d']%> - <%=par['e']%>x)$ $\Rightarrow$ $<%=a%> x - <%=a%>x - <%=c%> = x - <%=d%> + <%=e%>x$ $\Rightarrow$ $<%=a-b-1-e%>x = <%=-d+c%>$ $\Rightarrow$ $x = \frac{<%=solucio_2.numerator%>}{<%=solucio_2.denominator%>}$
<% end %>
\stopitemize


\stopitemize

\vfill
La resolució d'aquests exercicis s'ha calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject
\stopsubject
\stoptext
